tomcat-users mailing list archives

Site index · List index
Message view « Date » · « Thread »
Top « Date » · « Thread »
From Jacob Kjome <h...@visi.com>
Subject Re: strange error when processing stylesheets: tomcat, jdk1.4, windows, xalan
Date Thu, 01 Jul 2004 14:32:39 GMT
Quoting Martin Monsorno <lists@exolution.de>:

> Martin Monsorno <lists@exolution.de> writes:
> 
> > Hi *,
> >
> > I get the following error when trying to transform a xml document with
> > a XSLT stylesheet:
> >
> >     ; SystemID: jndi:/localhost/ipas/xsl/minutes_pdf.xsl; Line#: 298;
> Column#: 66
> >     javax.xml.transform.TransformerException: Unknown error in XPath
> >             at org.apache.xpath.XPath.bool(XPath.java:411)
> >             at org.apache.xalan.templates.ElemIf.execute(ElemIf.java:198)
> >     ...
> >
> > In the stylesheet, I test for an empty string:
> >
> >     <xsl:if test="not(string(./title))">
> >
> > The error occurs:
> >
> > - with ANY test condition that tests for an empty string
> >   (e.g. with "string-length(./entry) = 0"
> > - with having xalan.jar, xml-apis.jar and xercesImpl.jar in my
> >   WEB-INF/lib from any xalan versions of 2.5.0, 2.5.2, 2.6.0
> > - with Tomcat 4.1.29 on Windows 2000 and JDK 1.4x
> > - NOT with JDK 1.3

Well, this should be obvious by now.  JDK1.4+ ships with Xalan.  As such, it is
an "endorsed" library.  You shouldn't be putting endorsed libraries in
WEB-INF/lib.  Since Tomcat adds Xerces and xml-apis to common/endorsed, they
become "endorsed" libraries as well.  Tomcat classloaders will actively ignore
endorsed libraries sitting in WEB-INF/lib.  As such, your own versions of the
libraries are doing nothing whatsoever being there.  If you want to update
Tomcat with the latest Xerces and xml-apis, delete the existing ones from
common/endorsed and add yours there.  You can also add Xalan there, but probably
should add it to JAVA_HOME/jre/lib/endorsed (create the directory if it doesn't
already exist).  I suggest you use the "2jars" release to avoid making BCel
(which Xalan ships with... and old version at that) an endorsed library.  If
things don't work after this, then I'm at a loss.

> > - NOT on Linux
> > - NOT with resin
> 
> Ah, yes, and it does NOT occur when running the transforming by
> directly calling xalan from the command line and not via TomCat!
> 


Jake


> 
> --
> Martin
> 
> ---------------------------------------------------------------------
> To unsubscribe, e-mail: tomcat-user-unsubscribe@jakarta.apache.org
> For additional commands, e-mail: tomcat-user-help@jakarta.apache.org

---------------------------------------------------------------------
To unsubscribe, e-mail: tomcat-user-unsubscribe@jakarta.apache.org
For additional commands, e-mail: tomcat-user-help@jakarta.apache.org


Mime
View raw message